@set SNESSDK_HOME=c:\snessdk

@REM Clean
del *.ps
del *.s
del *.obj
del *.sym
del *.smc

@REM Assemble
%SNESSDK_HOME%\bin\816-tcc.exe -Wall -I../include -o snesc.s -c snesc.c
%SNESSDK_HOME%\bin\816-tcc.exe -Wall -I../include -o input.s -c input.c
%SNESSDK_HOME%\bin\816-tcc.exe -Wall -I../include -o init.s -c init.c
%SNESSDK_HOME%\bin\816-tcc.exe -Wall -I../include -o graph.s -c graph.c
%SNESSDK_HOME%\bin\816-tcc.exe -Wall -I../include -o str.s -c str.c

@REM Sebastian: I removed this (without affecting the functionality of the 
@REM resulting ROM) because I really don't like a dependency on Python in a 
@REM lower-level dev kit.
@REM 
@REM Optimize ASM files
@REM ..\bin\816-opt.py snesc.ps > snesc.s
@REM ..\bin\816-opt.py input.ps > input.s
@REM ..\bin\816-opt.py init.ps > init.s
@REM ..\bin\816-opt.py graph.ps > graph.s
@REM ..\bin\816-opt.py str.ps > str.s

@REM Compile
%SNESSDK_HOME%\bin\wla-65816.exe -io data.asm data.obj

%SNESSDK_HOME%\bin\wla-65816.exe -io snesc.s snesc.obj
%SNESSDK_HOME%\bin\wla-65816.exe -io input.s input.obj
%SNESSDK_HOME%\bin\wla-65816.exe -io init.s init.obj
%SNESSDK_HOME%\bin\wla-65816.exe -io graph.s graph.obj
%SNESSDK_HOME%\bin\wla-65816.exe -io str.s str.obj

@REM Link
%SNESSDK_HOME%\bin\wlalink.exe -dvSo data.obj snesc.obj input.obj init.obj graph.obj str.obj arkanoid.smc

@REM Clean
del *.ps
del *.s
del *.obj
del *.sym

